﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Runtime.InteropServices;

namespace CUEImporter
{
    public sealed class AudioLengthGetter : IDisposable
    {
        private static AudioLengthGetter _instance = null;
        public static AudioLengthGetter instance
        {
            get
            {
                if (_instance == null)
                {
                    _instance = new AudioLengthGetter();
                }
                return _instance;
            }
        }
        public bool isOK = false;
        private AudioLengthGetter()
        {
            if (BASS.isAvailable() == false) {
                isOK = false;
                return;
            }

            string[] pinnames = { "bassflac.dll", "bass_tta.dll", "bass_wv.dll", "bass_ape.dll", "bass_wma.dll", "bass_aac.dll", "bass_alac.dll", "bass_tak.dll", "plugin\\bassflac.dll", "plugin\\bass_tta.dll", "plugin\\bass_wv.dll", "plugin\\bass_ape.dll", "plugin\\bass_wma.dll", "plugin\\bass_aac.dll", "plugin\\bass_alac.dll", "plugin\\bass_tak.dll", };
            foreach (string pinname in pinnames)
            {
                bool Ok = BASS.BASS_PluginLoad(pinname, 0);
            }
            isOK = true;
        }

        public string getStatusMsg()
        {
            if(!BASS.isAvailable()){
                return "Bass.dll ロードできませんでした";
            }
            StringBuilder buf = new StringBuilder();
            buf.AppendLine("Bass.dll ロード成功");
            List<string> loadedBASSPlugins = BASS.getLoadedPlugins();
            buf.Append(" プラグイン{");
            foreach (string pinname in loadedBASSPlugins)
            {
                buf.Append(" " + System.IO.Path.GetFileName(pinname)+" ");
            }
            buf.AppendLine("}を読み込みました");
            return buf.ToString();
        }
        public float getLength(string filename)
        {
            IntPtr stream = (IntPtr)0;
            UInt64 pos = 0;
            float sec = 0;
            try {
                stream = BASS.BASS_StreamCreateFile(false, filename, 0, 0, 0);
                pos = BASS.BASS_ChannelGetLength(stream, 0); // 0 == BASS_POS_BYTE
                sec = BASS.BASS_ChannelBytes2Seconds(stream, pos);
            } catch (Exception) {
            } finally {
                BASS.BASS_StreamFree(stream);
            }
            return sec;
        }
        public void Dispose()
        {
            BASS.Dispose();
        }
    }
}
