#include "bass.h"
#include "bass-addon.h"
#include "sqlite3.h"
#include <windows.h>
#include <stdio.h>
#include <tlhelp32.h>
#include <Dbghelp.h>
#pragma comment(lib, "Dbghelp.lib")
#pragma comment(lib, "bass.lib")
#pragma comment(lib, "sqlite3.lib")

#ifndef BASSWMADEF
#define BASSWMADEF(f) WINAPI f
#endif

#define BASS_CTYPE_STREAM_WMA 0x10a00 // WMA
//ꂠ܂֌WȂ悭킩

#define BUFSIZE 512
typedef HSTREAM (CALLBACK *DLL_PROC)(BOOL, const void *, QWORD , QWORD , DWORD );
typedef FARPROC (CALLBACK *DLL_PROC_BASSPLUGIN)(UINT);
typedef HSTREAM (CALLBACK *STREAMCREATEPROC_REAL)(BASSFILE,DWORD);

enum extension{WMA,TTA,APE,WV,FLAC,TAK,EXT_END};

typedef struct dllinfo{
	wchar_t *file_name;
	HMODULE dll;
}DLLINFO;

// handle and ptrs
DLLINFO dlls[EXT_END];
DLL_PROC dll_proc; //pointer to "StreamCreateFile" proc. of the real basswma.dll
HANDLE thread = NULL;
DWORD thid; // thread id
HWND hH2k6 = NULL;
sqlite3* db = NULL;

// info about playing stream
HSTREAM current_stream;
WCHAR current_filename[BUFSIZE];
int Volume = -1;
double startPos = 0.0;
double endPos = 0.0;

// sub thread flags
bool watcherThreadActive = false;
bool toInit = false;

// bass plugin information
static const BASS_PLUGINFORM pluginforms[]={ //ꂠ܂֌WȂ悭킩
	{BASS_CTYPE_STREAM,"CUE sheet","*.cue"},
};
static const BASS_PLUGININFO plugininfo={0x02030000,1,pluginforms};

/*

  sqlite3_prepare16_v2hook
  http://ruffnex.oc.to/kenji/text/api_hook/

*/
typedef int (*PFSQLITE3_PREPARE16_V2)(sqlite3*,const void*,int,sqlite3_stmt**,const void **);
PFSQLITE3_PREPARE16_V2 sqlite3_prepare_org;

int hook_sqlite3_prepare16_v2(sqlite3* pDB,const void *zSql,int nByte,sqlite3_stmt** ppStmt,const void **pzTail){
	if(db == NULL)db=pDB;
	return sqlite3_prepare_org(pDB,zSql,nByte,ppStmt,pzTail);
}

// ЂƂ̃W[ɑ΂APItbNs֐
void ReplaceIATEntryInOneMod(
                             PCSTR pszModuleName,
                             PROC pfnCurrent,
                             PROC pfnNew,
                             HMODULE hmodCaller) 
{
    ULONG ulSize;
    PIMAGE_IMPORT_DESCRIPTOR pImportDesc;
    pImportDesc = (PIMAGE_IMPORT_DESCRIPTOR)ImageDirectoryEntryToData(
        hmodCaller, TRUE, IMAGE_DIRECTORY_ENTRY_IMPORT, &ulSize);

    if (pImportDesc == NULL)
        return;

    while(pImportDesc->Name) {
        PSTR pszModName = (PSTR) ((PBYTE) hmodCaller + pImportDesc->Name);
        if (lstrcmpiA(pszModName, pszModuleName) == 0) 
            break;
        pImportDesc++;
    }

    if (pImportDesc->Name == 0)
        return;

    PIMAGE_THUNK_DATA pThunk = (PIMAGE_THUNK_DATA) 
        ((PBYTE) hmodCaller + pImportDesc->FirstThunk);

    while(pThunk->u1.Function) {
        PROC *ppfn = (PROC*) &pThunk->u1.Function;
        BOOL fFound = (*ppfn == pfnCurrent);
        if (fFound) {
            DWORD dwDummy;
            VirtualProtect(ppfn, sizeof(ppfn), PAGE_EXECUTE_READWRITE, &dwDummy);
            WriteProcessMemory(
                GetCurrentProcess(), ppfn, &pfnNew, sizeof(pfnNew), NULL);
            return;
        }
        pThunk++;
    }
    return;
}

// ׂẴW[ɑ΂APItbNs֐
void ReplaceIATEntryInAllMods(
                              PCSTR pszModuleName, 
                              PROC pfnCurrent, 
                              PROC pfnNew) 
{
    // W[Xg擾
    HANDLE hModuleSnap = CreateToolhelp32Snapshot(
        TH32CS_SNAPMODULE, GetCurrentProcessId());
    if(hModuleSnap == INVALID_HANDLE_VALUE)
        return;

    MODULEENTRY32 me;
    me.dwSize = sizeof(me);
    BOOL bModuleResult = Module32First(hModuleSnap, &me);
    // ꂼ̃W[ɑ΂ReplaceIATEntryInOneMods
    while(bModuleResult) {        
        ReplaceIATEntryInOneMod(pszModuleName, pfnCurrent, pfnNew, me.hModule);
        bModuleResult = Module32Next(hModuleSnap, &me);
    }
    CloseHandle(hModuleSnap);
}

// find "H2k6" window
BOOL CALLBACK EnumWindowsProc(HWND hwnd , LPARAM lp) {
	DWORD pid = NULL;
	GetWindowThreadProcessId(hwnd,&pid);
	if(pid == GetCurrentProcessId()){
		WCHAR buf[BUFSIZE];
		wsprintf(buf,L"%d",pid);
		GetWindowText(hwnd,buf,BUFSIZE);
		if(wcscmp(buf,L"H2k6")==0){
			hH2k6 = hwnd;
			return false; // end
		}
	}
	return true;
}

// Send message to H2k6 volume track-bar to change volume.
void setH2k6Volume(int vol){ // vol: 0 to 100
	HWND statusbar = FindWindowExA(hH2k6,NULL,"msctls_statusbar32",NULL);
	if(statusbar == NULL)return;
	HWND trackbar = FindWindowExA(statusbar,NULL,"msctls_trackbar32",NULL);
	if(trackbar == NULL)return;
	SendMessage(trackbar,WM_USER+5,1,vol); // TBM_SETPOS
	SendMessage(statusbar,WM_HSCROLL,8,(LPARAM)trackbar);
}
// get H2k6 Volume into argument.
// return true/false if success or not.
bool getH2k6Volume(int* vol){
	HWND statusbar = FindWindowExA(hH2k6,NULL,"msctls_statusbar32",NULL);
	if(statusbar == NULL)return false;
	HWND trackbar = FindWindowExA(statusbar,NULL,"msctls_trackbar32",NULL);
	if(trackbar == NULL)return false;
	*vol = SendMessage(trackbar,WM_USER+0,0,0);
	return true;
}

// V[No[̍ŏEőlcuẽt@C̊egbN̕ɍ킹
// [UV[No[𑀍삵ƂɕςȋɂȂ̂ŕۗ
void SendMessageToH2k6SeekBar(UINT Msg,LPARAM lParam){
	return;
	HWND rebar = FindWindowExA(hH2k6,NULL,"ReBarWindow32",NULL);
	if(rebar == NULL)return;
	HWND dlg = FindWindowExA(rebar,NULL,"#32770",NULL);
	if(dlg == NULL)return;
	HWND trackbar = FindWindowExA(dlg,NULL,"msctls_trackbar32",NULL);
	if(trackbar == NULL)return;
	SendMessage(trackbar,Msg,1,lParam);
}

// current_streamĎXbh
DWORD WINAPI subThread(LPVOID lpV) {
	QWORD pos;
	double currentPos;
	DWORD stat;
	WCHAR wbuf[BUFSIZE*2];
	CHAR u8buf[BUFSIZE*2];
	EnumWindows(EnumWindowsProc,NULL); // H2k6hWND擾
	PROC pfnOrig; // sqlite3hook
	pfnOrig = GetProcAddress(GetModuleHandleW(L"sqlite3.dll"), "sqlite3_prepare16_v2");	
	ReplaceIATEntryInAllMods("sqlite3.dll", pfnOrig, (PROC)hook_sqlite3_prepare16_v2);
	sqlite3_prepare_org = (PFSQLITE3_PREPARE16_V2)pfnOrig;

	dlls[ WMA].file_name=L"plugin\\bass_wma.dll";
	dlls[ TTA].file_name=L"plugin\\bass_tta.dll";
	dlls[ APE].file_name=L"plugin\\bass_ape.dll";
	dlls[  WV].file_name=L"plugin\\bass_wv.dll";
	dlls[FLAC].file_name=L"plugin\\bassflac.dll";
	dlls[ TAK].file_name=L"plugin\\bass_tak.dll";
	for(int i=0;i<EXT_END;i++){
		dlls[i].dll=LoadLibrary(dlls[i].file_name);
	}
	dll_proc=(DLL_PROC)GetProcAddress(dlls[WMA].dll,"BASS_WMA_StreamCreateFile");

	while(true){
		Sleep(2);
		if(!watcherThreadActive){
			Sleep(25);continue;
		}
		stat = BASS_ChannelIsActive(current_stream);
		if(stat == BASS_ACTIVE_STOPPED){
			Sleep(25);
			continue;
		}
		if(stat == BASS_ACTIVE_PLAYING){
			if(toInit){
				BASS_ChannelPause(current_stream);
				pos = BASS_ChannelSeconds2Bytes(current_stream,startPos);
				BASS_ChannelSetPosition(current_stream,pos,BASS_POS_BYTE);
				SendMessageToH2k6SeekBar(WM_USER+7,pos); // set seekbar min
				if(endPos > 0){
					SendMessageToH2k6SeekBar(WM_USER+8,BASS_ChannelSeconds2Bytes(current_stream,endPos));
				}
				setH2k6Volume(Volume);
				Volume = -1;
				BASS_ChannelPlay(current_stream,false);

				Sleep(5);
				toInit = false;
				continue;
			}
			currentPos = BASS_ChannelBytes2Seconds( current_stream,BASS_ChannelGetPosition(current_stream,BASS_POS_BYTE) );
			if( (currentPos > 0) && (currentPos+1 < startPos) ){ // before startPos
				BASS_ChannelSetPosition(current_stream,BASS_ChannelSeconds2Bytes(current_stream,startPos),BASS_POS_BYTE);
				continue;
				Sleep(10);
			}else if((endPos > 0)&&(currentPos > endPos)){ // after endPos -> set Pos to end of stream -> next track
				BASS_ChannelSetAttribute(current_stream,BASS_ATTRIB_VOL,0);
				wsprintf(wbuf,L"UPDATE list SET playcount=playcount+1,lastplayed=current_timestamp64() WHERE file_name = \"%s\";",current_filename);
				WideCharToMultiByte(CP_UTF8,NULL,wbuf,-1,u8buf,BUFSIZE*2-1,NULL,NULL);
				sqlite3_stmt* statement;
				sqlite3_prepare16_v2(db,wbuf,-1,&statement,NULL);
				sqlite3_reset(statement);
				sqlite3_step(statement);
				sqlite3_finalize(statement);
				BASS_ChannelStop(current_stream);
				Sleep(15);
				PostMessage(hH2k6,WM_HOTKEY,33,0);
//				BASS_ChannelSetPosition(channel,BASS_ChannelGetLength(channel,BASS_POS_BYTE)-1000,BASS_POS_BYTE);
				continue;
			}
		}
	}
	return 0;
}

BOOL WINAPI DllMain( HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved){
	switch(fdwReason){
		case DLL_PROCESS_ATTACH: //initialize
			thread = CreateThread(NULL,NULL,subThread,NULL,NULL,&thid);
			SetPriorityClass(thread,THREAD_PRIORITY_LOWEST);

			break;
		case DLL_PROCESS_DETACH:
			if(thread){
				TerminateThread(thread,NULL);
				CloseHandle(thread);
				thread = NULL;
			} 
			/* PROCESS_DETACHFreeLibrary͂낵Ȃ炵BfreeȂقނ낢H */
			for(int i=0;i<EXT_END;i++){
				FreeLibrary(dlls[i].dll);
			}
			break;
	}

	return TRUE;
}

int parseCUE(const LPWSTR filename,const int track,LPWSTR filename_real, extension* ext,double* startPos_and_endPos){
	CHAR buf[BUFSIZE]; // line buffer
	WCHAR mb_to_wide[BUFSIZE];
	CHAR *ptr;
	FILE *fp;
//	BOOL UPDATE_FILE_LINE = true;
	bool isUnicode = false; // unicode : support utf8(bom) only ;;
	bool joinWithNextTrack = true;
	int count = 0;
	int min,sec,frame;

	startPos_and_endPos[0] = 0.0;
	startPos_and_endPos[1] = -1;
	wcscpy_s(filename_real,BUFSIZE,filename);
	filename_real = wcsrchr(filename_real,L'\\')+1;
	_wfopen_s(&fp,filename,L"r");
	if(fp == NULL){
		return 1;
	}
	while(fgets(buf,BUFSIZE,fp)!=NULL){
		ptr = buf;
		if((ptr[0] == 0xEF)&&(ptr[1] == 0xBB)&&(ptr[2] == 0xBF)){ // BOM
			isUnicode = true;
			ptr+=3;
		}
		while((*ptr == ' ')||(*ptr == '\t')){ // s̋󔒂ؗɃX[
			ptr++;
		}
		if( strncmp(ptr,"FILE",4) == 0 ){ // FILE̍ŝƂ
			if(count >= track){
				joinWithNextTrack = false; continue;
			}else{
				if(strchr(ptr,'"') != NULL){
					ptr = strchr(ptr,'"')+1;
				}else{
					ptr = strchr(ptr,' ')+1;
				}
				if(strrchr(ptr,'"') != NULL){
					*(strrchr(ptr,'"'))='\0';
				}else{
					if(strrchr(ptr,'"') != NULL){
						*(strrchr(ptr,' '))='\0';
					}
				}
				if(isUnicode){
					MultiByteToWideChar(CP_UTF8,0,ptr,BUFSIZE,mb_to_wide,BUFSIZE);
				}else{
					MultiByteToWideChar(CP_ACP,0,ptr,BUFSIZE,mb_to_wide,BUFSIZE);
				}
				wcscpy_s(filename_real,BUFSIZE,mb_to_wide);
				if( track == 0 ){
					break; //͂肦ȂH
				}
			}
			continue;
		}
		if( strncmp(ptr,"TRACK",5) == 0){ // TRACK̍ŝƂ
			count++;
		}
		if( count == track ){
			if(strncmp(ptr,"INDEX 01 ",9) == 0){
				ptr += 9;
				min = atoi(ptr);
				sec = atoi(ptr+3);
				frame = atoi(ptr+6);
				startPos_and_endPos[0] = min*60+sec+frame/75.0;
			}
			continue;
		}
		if( count == (track+1) ){
			if(strncmp(ptr,"INDEX 01 ",9) == 0){ // INDEXŝƂ
				ptr += 9;
				min = atoi(ptr);
				sec = atoi(ptr+3);
				frame = atoi(ptr+6);
				if(joinWithNextTrack){
					startPos_and_endPos[1] = min*60+sec+frame/75.0;
				}
				break;
			}
		}
	}
	_fclose_nolock(fp);
	return 0;
}


/*

  bass pluginƂĂ̊֐

*/
HSTREAM BASSWMADEF(BASS_WMA_StreamCreateFile)(BOOL mem, const void *file, QWORD offset, QWORD length, DWORD flags){
	if(dlls[WMA].dll == NULL){return NULL;} //G[̎Ԃ΂ׂĂȂ
	return dll_proc(mem,file,offset,length,flags);
}

HSTREAM WINAPI StreamCreateProc(BASSFILE file, DWORD flags){
	BOOL i=true;
	WCHAR buf[BUFSIZE]; // filename buffer
	WCHAR buf_cue_real[BUFSIZE];
	WCHAR* ext; // extension
	int trCount = 0;
	double startPos_and_endPos[2];
	extension file_type = WMA;
	DLL_PROC_BASSPLUGIN dll_proc_real; //pointer to "BASSPlugin" proc. of the `REAL' dll file
	STREAMCREATEPROC_REAL StreamCreateProc_real; //pointer to "StreamCreateProc" proc. of the `REAL' dll file

	wcsncpy_s(buf,BUFSIZE-1,(const wchar_t *)bassfunc->file.GetFileName(file,&i),BUFSIZE-1);
	while(buf[wcslen(buf)-1] == L' '){
		trCount++;
		buf[wcslen(buf)-1] = L'\0';
	}
	ext = wcsrchr(buf,'.')+1;
	while(buf[wcslen(buf)-1] == L' '){
		trCount++;
		buf[wcslen(buf)-1] = L'\0';
	}
	CharUpperW(ext);

	if(wcscmp(ext,L"CUE")==0){
		wcsncpy_s(current_filename,BUFSIZE-1,(const wchar_t *)bassfunc->file.GetFileName(file,&i),BUFSIZE-1);
		int err = parseCUE(buf,trCount,buf_cue_real,&file_type,startPos_and_endPos);
		if(err){
			current_stream = NULL;
			return NULL;
		}
		ext = wcsrchr(buf_cue_real,'.')+1;
		CharUpperW(ext);

		startPos = startPos_and_endPos[0];
		endPos = startPos_and_endPos[1];
		if(Volume == -1){
			getH2k6Volume(&Volume);
		}

		current_stream = BASS_StreamCreateFile(false,buf_cue_real,0,0,BASS_UNICODE);
		toInit = true;
		setH2k6Volume(0);
//		BASS_ChannelSetAttribute(current_stream,BASS_ATTRIB_VOL,0);
		watcherThreadActive = true;
		bassfunc->file.SetStream(file,current_stream);
	}else{
		if( (wcscmp(ext,L"ASF")==0) || (wcscmp(ext,L"WMA")==0) )
			file_type=WMA;
		else if( (wcscmp(ext,L"FLAC")==0) || (wcscmp(ext,L"FLA")==0) )
			file_type=FLAC;
		else if( wcscmp(ext,L"APE")==0 )
			file_type=APE;
		else if( wcscmp(ext,L"TTA")==0 )
			file_type=TTA;
		else if( wcscmp(ext,L"WV")==0 )
			file_type=WV;
		else if( wcscmp(ext,L"TAK")==0 )
			file_type=TAK;

		if(dlls[file_type].dll == NULL){MessageBoxW(NULL,dlls[file_type].file_name,L"dll not found",MB_OK);return NULL;}
		dll_proc_real = (DLL_PROC_BASSPLUGIN)GetProcAddress(dlls[file_type].dll,"BASSplugin"); // get "BASSPlugin" proc
		StreamCreateProc_real = (STREAMCREATEPROC_REAL)dll_proc_real(BASSPLUGIN_CREATE); // get "StreamCreateProc" proc
		current_stream = StreamCreateProc_real(file,flags);
	}
	return current_stream;
}

const void *WINAPI BASSplugin(DWORD face){
	switch (face) {
		case BASSPLUGIN_INFO:
			return &plugininfo;
		case BASSPLUGIN_CREATE:
			return (void*)&StreamCreateProc;
	}
	return NULL;
}

